/*
These are additional actions not defined in the core BYOND MUD library.
*/

action/browse
	var
		file
	Write(savefile/F)
		..()
		F << src.file
	Read(savefile/F)
		..()
		F >> src.file
	DesignerInfo()
		..()
		usr << "file = [src.file]"
	Configure()
		..()
		src.file = input("File",,src.file) as text|file
	Action()
		..()
		usr << browse(file(src.file))

action/local_link
	/*Local Link Action

	  This action is used to jump players to a local world, which is
	  automatically started up when accessed if not already running.  The
	  player is not exported to the world, so this is intended for
	  supplementary worlds that are not directly part of the game (like a
	  message board).
	*/
	var
		port = 0  //randomly assigned port by default
		file      //dmb file to run
		params    //optional parameter string
		tmp/addr  //current address of world (ip:port)
	Write(savefile/F)
		..()
		F << port
		F << file
		F << params
	Read(savefile/F)
		..()
		F >> port
		F >> file
		F >> params
	DesignerInfo()
		..()
		usr << "port = [port]"
		usr << "world file = [file]"
		usr << "world params = [params]"
		usr << "address = [addr]"
	Configure()
		..()
		port = input("Default Port",,port) as num
		file = input("World File",,file)
		params = input("Parameters",,params)
	Action()
		if(!usr.key) return //don't let NPCs do this!

		if(!addr && port)
			addr = "[world.address]:[port]"
			if(!world.Export("[addr]?ping")) addr = null
			else if(!usr) return //player died
		if(!addr)
			addr = startup(file,port,"-once","-safe","-logself","-params",params)
			if(!addr) return
			if(!usr) //player died
				shutdown(addr)
				return
			spawn
				shutdown(addr,1) //wait for shutdown
				addr = null
		..()

		//TODO: should mark savefile as exported
		if(!usr) world.log << "WARNING: bad usr in local_link."
		mud.SavePlayer(usr)
		usr << link("byond://[addr]")
		del usr
